/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2008-2014 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: domain.h 1003 2014-04-23 11:58:48Z ertl-hiro $
 */

/*
 *		ݸɥᥤ⥸塼
 */

#ifndef TOPPERS_DOMAIN_H
#define TOPPERS_DOMAIN_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ݸɥᥤ֥å
 */
typedef struct domain_initialization_block {
	ACPTN		domptn;			/* ݸɥᥤΥӥåȥѥ */
	uint_t		minpriority;	/* Ǥ륿ͥ٤κǾ */
#ifdef USE_DOMINICTXB
	DOMINICTXB	domctxb;		/* ݸɥᥤƥȥ֥å */
#endif /* USE_DOMINICTXB */
} DOMINIB;

/*
 *  ݸɥᥤIDκ͡kernel_cfg.c
 */
extern const ID	tmax_domid;

/*
 *  ݸɥᥤ֥åΥꥢkernel_cfg.c
 */
extern const DOMINIB	dominib_table[];

/*
 *  ͥɥᥤݸɥᥤ֥åkernel_cfg.c
 */
extern const DOMINIB	dominib_kernel;

/*
 *  ݸɥᥤIDݸɥᥤ֥åФΥޥ
 */
#define INDEX_DOM(domid)	((uint_t)((domid) - TMIN_DOMID))
#define get_dominib(domid)	(&(dominib_table[INDEX_DOM(domid)]))

/*
 *  ݸɥᥤ֥åݸɥᥤIDФΥޥ
 */
#define	DOMID(p_dominib)	(((p_dominib) == &dominib_kernel) ? TDOM_KERNEL \
							: (ID)(((p_dominib) - dominib_table) + TMIN_DOMID))

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_DOMAIN_H_ */
